#!/usr/bin/perl -w
#-----------
#  URL reference: http://www.amelek.gda.pl/avr/uisp/srecord.htm
#-----------
#  example use:
#  tomw@tomw-Lenovo:~/Downloads/APF-Files/Yahoo$ cat nUMgUESS.TXT | perl checksums.pl
#-----------
#  tom.williams, 12-Dec-2011.
#-----------
use strict;

my ( $in, $i, $j, $byt, @bytarry, $dec, $sum, $compl, $x );
my @outbytes;
$x=1;
while (<>){
   $in = $_;
   $in =~ s/[ \n\r]//g;  # eliminate spaces, cr and lf characters.
   $in = uc( $in );
   print $in . "\n";
   undef @bytarry;
   if ( $in =~ m/^S1.*/ ){
     $i = length($in);
     for( $j = 0; $j < $i; $j+=2 ){
        $byt = substr( $in, $j, 2 );
        push @bytarry, $byt;
     }
     $sum=0;
     $j = scalar( @bytarry );  # j = number of elements in array.
     foreach $byt (@bytarry) {
        $dec=0;
        if (!( $byt =~ m/^S1/ )){
           $dec = hex( $byt );
        }
        $sum += $dec;
     ##   printf( " 0x$byt => $dec => sum=$sum=0x%04X\n", $sum);
        if ( --$j != 0 ){ push @outbytes, $dec; }  # this is the byte for the binary output file.
     }
     $compl=(255-($sum%256));
     printf ( " complemint sum=$compl = 0x%02X\n\n",$compl);
     if ( $compl != 0 ){ print "********* ERROR on line [$x] ********************\n"; }
   } else {
     print "line $x not an S1 record... skipping.\n\n";
   }
   $x++;
}
print "\n\n Writing output file: outfile.bin \n\n";
open( OUTF, ">outfile.bin" ) || die "\nCould not open outfile.bin for writing in current directory.\n\n";
foreach $byt (@outbytes){
   print OUTF chr($byt);
}
close OUTF;
print " done.\n\n";
exit 0;
